# Ηλεκτρονική υπηρεσία δηλώσεων προτίμησης ΕΠΑΛ για το νέο σχολικό έτος 

## Περιγραφή

Η Ηλεκτρονική Υπηρεσία δηλώσεων προτίμησης Επαγγελματικών Λυκείων (ΕΠΑΛ) για το νέο σχολικό έτος αναπτύσσεται με κύριο σκοπό να παρέχει τη δυνατότητα ηλεκτρονικής δήλωσης προτίμησης των μαθητών για φοίτηση σε ΕΠΑΛ της χώρας μας, καθώς και την κατανομή τους σε αυτά με βάση συγκεκριμένα κριτήρια και λαμβάνοντας υπόψη τις προτιμήσεις τους.  Η υπηρεσία υλοποιήθηκε από την ομάδα [Ανοικτού Λογισμικού του Υπουργείου Παιδείας](http://ostmgmt.minedu.gov.gr), η οποία είναι αρμόδια για τον Σχεδιασμό, Ανάπτυξη και Συντήρηση Εφαρμογών Ανοικτού Λογισμικού του ΥΠΠΕΘ και υπάγεται στη Γενική Διεύθυνση Στρατηγικού Σχεδιασμού, Προγραμματισμού και Ηλεκτρονικής Διακυβέρνησης.

Οι διαδικασίες υλοποίησης του έργου ακολουθούν τη μεθοδολογία ευέλικτης ανάπτυξης λογισμικού Agile σε πρότυπα Scrum, που υπόσχεται ανταπόκριση στις αλλαγές, παραγωγικότερες πρακτικές και λιγότερη γραφειοκρατία. Η ανταπόκριση στις αλλαγές αναφέρεται κυρίως στην συνολική ικανότητα της διαδικασίας ανάπτυξης να προσαρμόζεται ανάλογα όταν προκύπτουν αλλαγές στην πορεία του έργου, καθώς και στην ανάγκη για συνεργασία μεταξύ όλων των συμμετεχόντων.  Η μέθοδος αυτή είναι μια επαναληπτική και αυξητική προσέγγιση για την ανάπτυξη έργων που επιτρέπει την προσαρμογή στις αλλαγές που προκύπτουν.

Στην διαδικασία αυτή παρουσιάζονται οι εξής τρεις βασικοί ρόλοι: 
* ο ιδιοκτήτης του προϊόντος (The Product Owner) είναι η Διεύθυνση Επαγγελματικής Εκπαίδευσης και υπεύθυνος ο Δ/ντης  κ. Μουστάκας Γ. που κατέχει καθοριστικό ρόλο στην ανάπτυξη του συστήματος, εντοπίζοντας τα χαρακτηριστικά της υπηρεσίας και μεταφράζοντας τα σε μια λίστα απαιτήσεων 
* η ομάδα (team) που χτίζει το προιόν (μέλη της ομάδας του Ανοικτού Λογισμικού) 
* η ομάδα εποπτείας (Advisor Board) που αποτελείται από έμπειρα άτομα του χώρου της επαγγελματικής εκπαίδευσης με βασικό σκοπό την σύνταξη απαιτήσεων και την ιεράρχηση τους (Product Backlog)

## Παραγωγική λειτουργία 

Η [Ηλεκτρονική Υπηρεσία δηλώσεων προτίμησης Επαγγελματικών Λυκείων (ΕΠΑΛ)](https://e-epal.minedu.gov.gr) λειτουργεί παραγωγικά από τον Ιούνιο 2017 στη διεύθυνση [e-epal.minedu.gov.gr](https://e-epal.minedu.gov.gr), σύμφωνα με την [Υπουργική Απόφαση με αρ.πρωτ. Φ1α/98933/Δ4](https://e-epal.minedu.gov.gr/pdfs/files/ypourgikh.pdf) που δημοσιεύτηκε στο ΦΕΚ ΦΕΚ B 2075/2017. Όλα τα σχετικά έγγραφα που αφορούν τη λειτουργία της υπηρεσίας είναι [διαθέσιμα και από τον επίσημο ιστότοπο](https://e-epal.minedu.gov.gr/#/legal-info). 

## Περιβάλλον Ανάπτυξης

Όλα τα κείμενα και ο κώδικας που υλοποιείται βρίσκονται στο αποθετήριο [git.minedu.gov.gr/itminedu/e-epal](https://git.minedu.gov.gr/itminedu/e-epal).

Οι προδιαγραφές του έργου σύμφωνα με τα πρότυπα της μεθοδολογίας Agile / Scrum είναι διαθέσιμες στο [git.minedu.gov.gr/itminedu/e-epal/wikis/scrum](https://git.minedu.gov.gr/itminedu/e-epal/wikis/scrum).

Η αναλυτική τεκμηρίωση των λειτουργικών απαιτήσεων συντηρείται στο [git.minedu.gov.gr/itminedu/e-epal/wikis/analysis](https://git.minedu.gov.gr/itminedu/e-epal/wikis/analysis).

## Παρατηρήσεις - Σχόλια

Όλοι οι συμμετέχοντες στο έργο με οποιαδήποτε ιδιότητα (Ιδιοκτήτες Προϊόντος, Ομάδα Ανάπτυξης, Ομάδα Εποπτείας) μπορούν να αναρτούν τις παρατηρήσεις και σχόλιά τους στο [git.minedu.gov.gr/itminedu/e-epal/issues](https://git.minedu.gov.gr/itminedu/e-epal/issues).

## Άδεια χρήσης 

Code licence: [EUPL v1.1](http://ec.europa.eu/idabc/eupl.html) 

Content licence: [CC-BY-SA 4.0](https://creativecommons.ellak.gr/2015/08/21/%CE%B5%CE%BD%CE%B1%CF%82-%CE%B1%CF%80%CE%BB%CF%8C%CF%82-%CE%BF%CE%B4%CE%B7%CE%B3%CF%8C%CF%82-%CE%B3%CE%B9%CE%B1-%CF%84%CE%B9%CF%82-%CE%AC%CE%B4%CE%B5%CE%B9%CE%B5%CF%82-creative-commons-4-0/)
